#include <cstdio>
#include <memory.h>
using namespace std;

const int MAX_N = 1<<10;

struct matrix {
	int n, m;
	int a[MAX_N][MAX_N];
};

matrix A; // author's input
matrix B; // contestant's solution

void read_input (char *f)
{
	FILE *fin = fopen(f,"r");

	int i, j;

	fscanf (fin, "%d%d", &A.n, &A.m);

	for (i=1; i<=A.n; i++)
		for (j=1; j<=A.m; j++)
			fscanf (fin, "%d", &A.a[i][j]);

	fclose(fin);
}

void read_output (char *f)
{
	FILE *fin = fopen(f,"r");

	int i, j;

	fscanf (fin, "%d", &B.n);
	
	for (i=1; i<=B.n; i++)
		for (j=1; j<=B.n; j++)
			fscanf (fin, "%d", &B.a[i][j]);

	fclose(fin);
}

bool correct_matrix ()
{
	int i, j, p;
	bool check[MAX_N];
	bool inderr(false);

	for (i=1; i<=B.n; i++) {
		memset(check,0,sizeof(check));

		for (j=1; j<=B.n; j++) {
			p = B.a[i][j];
			if (check[p]) inderr=true;
			else check[p]=true;  
		} 
	}

	for (j=1; j<=B.n; j++) {
		memset(check,0,sizeof(check));

		for (i=1; i<=B.n; i++) {
			p = B.a[i][j];
			if (check[p]) inderr=true;
			else check[p]=true;  
		}  
	}

	return !inderr;
}

bool match_with_author ()
{
	int i, j;

	if (A.m!=B.n) return 0;

	for (i=1; i<=A.n; i++)
		for (j=1; j<=A.m; j++)
			if (A.a[i][j] != B.a[i][j])
				return 0;

	return 1;
}

void check ()
{
	if (!correct_matrix()) printf ("The contestant's matrix is not valid itself!\n");
	else if (!match_with_author()) printf ("Doesn't match with author's matrix!\n");
	else printf ("OK\n");
}

int main (int argn, char* args[])
{
	if (argn!=3) {
		printf ("args: <IN file> <contestant's OUT file>\n");
		return 1;
	}
	
	read_input (args[1]);
	read_output (args[2]);
	check ();

	return 0;
}
